package org.apache.maven.deploy.deployers;

/* ====================================================================
 *   Copyright 2001-2004 The Apache Software Foundation.
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 * ====================================================================
 */

import org.apache.commons.lang.StringUtils;
import org.apache.maven.deploy.RepositoryInfo;
import org.apache.maven.deploy.DeployRequest;
import org.apache.maven.deploy.exceptions.AuthenticationException;
import org.apache.maven.deploy.exceptions.TransferFailedException;

import com.jcraft.jsch.ChannelSftp;
import com.jcraft.jsch.SftpATTRS;
import com.jcraft.jsch.SftpException;
import com.jcraft.jsch.SftpProgressMonitor;

/**
 * An SSH2/SFTP deployer 
 * 
 * @author Michal Maczka
 * @version $Revision: 1.9 $ $Date: 2004/03/02 14:59:31 $
 */
public class SFtpDeployer extends GenericSshDeployer
{
    /**Protocol understood by by this deployer*/
    public final static String PROTOCOL = "sftp://";

    /** SSH2 Chanel names used to communicate with the server*/
    private final static String SFTP_CHANNEL = "sftp";

    /** artibute of file used in SSH which denotes is given file is a directory*/
    private static final int S_IFDIR = 0x4000;

    private ChannelSftp channel = null;

    private Integer groupId = null;

    /* (non-Javadoc)
     * @see org.apache.maven.deploy.deployers.Deployer#init(org.apache.maven.deploy.HostInfo)
     */
    public void init(RepositoryInfo repoInfo)
        throws AuthenticationException
    {

        try
        {
            if (repoInfo.getGroup() != null)
            {
                groupId = Integer.getInteger(repoInfo.getGroup());
            }
        }
        catch (NumberFormatException e)
        {
            throw new AuthenticationException("SFTP deployer: remote group should be an integer");
        }
        super.init(repoInfo);

        channel = null;
        try
        {
            channel = (ChannelSftp) getSession().openChannel(SFTP_CHANNEL);
            channel.connect();
            channel.cd(repoInfo.getBasedir());
        }
        catch (Exception e)
        {
            throw new AuthenticationException(e.getMessage());
        }

    }

    /**
     * @see org.apache.maven.deploy.deployers.Deployer#release()
     */
    public void release()
    {
        channel.disconnect();
        super.release();
    }

    /**
     * @see Deployer#deploy(DeployRequest)
     */
    public void deploy(DeployRequest request) throws TransferFailedException
    {
        try
        {

            // iterate over all directories in the path. try to create
            // directory 
            String[] dirs = StringUtils.split(request.dirname(), "/");
            for (int i = 0; i < dirs.length; i++)
            {
                try
                {
                    SftpATTRS attrs = channel.stat(dirs[i]);
                    if ((attrs.getPermissions() & S_IFDIR) != 0)
                    {
                        // file exists and is dierctory                        
                        channel.cd(dirs[i]);
                    }
                    else
                    {
                        throw new TransferFailedException(
                            "Incorrect remote path:" + request.getDestFile());
                    }
                }
                catch (Exception e)
                {
                    // file most probably does not exists
                    channel.mkdir(dirs[i]);
                    channel.cd(dirs[i]);
                }

            }
            if (getRepositoryInfo().isDebugOn())
            {
                channel.put(
                    request.getSrcFile(),
                    request.filename(),
                    new ProgressMonitor());
            }
            else
            {

                channel.put(request.getSrcFile(), request.filename());

            }

            if (groupId != null)
            {
                if (getRepositoryInfo().isDebugOn())
                {
                    System.out.println("Changing group to: " + groupId);
                }
                channel.chgrp(groupId.intValue(), request.getDestFile());
                if (getRepositoryInfo().isDebugOn())
                {
                    System.out.println("Group successfully changed");
                }

            }
            // change back the working directory to repository root
            for (int i = 0; i < dirs.length; i++)
            {
                channel.cd("..");
            }
        }
        catch (SftpException e)
        {

            String msg =
                "Error occured while deploying to remote host:"
                    + getRepositoryInfo().getHost()
                    + ":"
                    + e.getMessage();
            throw new TransferFailedException(msg, e);
        }

    }

    class ProgressMonitor implements SftpProgressMonitor
    {

        public boolean count(long count)
        {
            System.out.print("#");
            return true;
        }

        public void end()
        {
            System.out.println();

        }

        public void init(int op, String src, String dest, long max)
        {

        }

    }

}
